/*********************/
/**** interface.h ****/
/*********************/

#include <stdio.h>
#include <rpc/rpc.h>

#define PROG_NUM 0x20000083
#define VERS_NUM 1

/* liste des operations disponibles sur un compte */

#define OPE_NUM 11
#define SEE_NUM 22



/*******************/
/**** serveur.c ****/
/*******************/

#include "inteface.h"

/* variables */

static long compte = 1234567 // compte (valeur courante)

/* fonctions */

long * operation (int * val)
{
  compte = compte + val;
  return &compte;
}

long * consult (void)
{
  return & compte;
}

int main(void)
{

  // xdr_int/xdr_long : type d'encodage paramtre puis rsultat
  if(registerrpc(PROG_NUM,VERS_NUM,OPE_NUM,operation,xdr_int,xdr_long)==-1)
  {
    perror(registerrpc);
    exit 1;
  }
  
  if(registerrpc(PROG_NUM,VERS_NUM,SEE_NUM,consulter,xdr_int,xdr_long)==-1)

  {
    perror(registerrpc);
    exit 1;
  }
  
  svc_run();
  
}



/******************/
/**** client.c ****/
/******************/

#include "interface.h"

/* variables */

int stat;
int compte;

/* fonctions */

void main(int argc,char * argv[])
{

  switch(argc)
  {
    
    case 1:
      
      stat=callrpc("sunserv",PROG_NUM,VERS_NUM,SEE_NUM,xdr_void,NULL,xdr_?,&compte);
      if(stat!=RPC_SUCCESS)
        clnt_perrno(stat);
      else
        printf("valeur du compte : %n\n",compte);
        
    break;    
        
    case 2:
    
      stat=callrpc("sunserv",PROG_NUM,VERS_NUM,OPE_NUM,xdr_void,NULL,xdr_?,&compte);
      if(stat!=RPC_SUCCESS)
        clnt_perrno(stat);
      else
        printf("valeur du compte : %n\n",compte);
        
    break;
    
    default:
    break;
    
  }

}



/*******************/
/**** effacer.c ****/
/*******************/

#include "interface.h"

main()
{

  pmap_unset(PROG_NUM,VERS_NUM);

}
