/******************************************
* Exercice 1 : Unix non connect / Client *
******************************************/
#include <stdio.h>
#include <sys/socket.h>
#include <sys/un.h>
#define TAILLEMAX 4000
#define EMISSION "./sock_emission"
#define RECEPTION "./sock_reception"

void main()
{
  int sock;
  char mess[TAILLEMAX],mess2[TAILLEMAX];
  struct sockaddr_un s_emission,s_reception;

  // initialisation
  unlink(EMISSION);
  unlink(RECEPTION);
  bzero(&s_emission,sizeof(s_emission));
  bzero(&s_reception,sizeof(s_reception));
  
  strcpy(s_emission.sun_path,EMISSION);
  strcpy(s_reception.sun_path,RECEPTION);
  
  // initialisation
  lg = sizeof(s_reception);
  sock = socket(AF_UNIX,SOCK_DGRAM,0);
  
  bind(sock,(struct sockaddr *)&s_emission,sizeof(s_emission));
  gets(mess);
  sendto(sock,mess2,sizeof(mess2),0,(struct sockaddr *)&s_reception,sizeof(s_reception));
  
  // attente
  
  recvfrom(sock,mess2,sizeof(mess2),0,(struct sockaddr *)&s_reception,&lg);
  close(sock);
}

/*******************************************
* Exercice 1 : Unix non connect / Serveur *
*******************************************/
#include <stdio.h>
#include <sys/socket.h>
#include <sys/un.h>
#define TAILLEMAX 4000
#define EMISSION "./sock_emission"
#define RECEPTION "./sock_reception"

void main()
{
  int sock;
  char mess[TAILLEMAX],mess2[TAILLEMAX];
  struct sockaddr_un s_reception;

  // initialisation
  unlink(RECEPTION);
  bzero(&s_reception,sizeof(s_reception));

  strcpy(s_reception.sun_path,RECEPTION);

  // initialisation
  lg = sizeof(s_reception);
  sock = socket(AF_UNIX,SOCK_DGRAM,0);
  
  bind(sock,(struct sockaddr *)&s_reception,sizeof(s_reception));
  recvfrom(sock,mess2,sizeof(mess2),0,(struct sockaddr *)&s_reception,&lg);

  // attente
  
  sendto(sock,mess2,sizeof(mess2),0,(struct sockaddr *)&s_reception,sizeof(s_reception));
  close(sock);
}

/**************************************
* Exercice 1 : Unix connect / Client *
**************************************/
#include <stdio.h>
#include <sys/socket.h>
#include <sys/un.h>
#define TAILLEMAX 4000
#define EMISSION "./sock_emission"
#define RECEPTION "./sock_reception"

void main()
{
  int sock;
  char mess[TAILLEMAX],mess2[TAILLEMAX];
  struct sockaddr_un server,s_emission,s_reception;

  // initialisation
  unlink(EMISSION);
  unlink(RECEPTION);
  bzero(&s_emission,sizeof(s_emission));
  bzero(&s_reception,sizeof(s_reception));
  
  strcpy(s_emission.sun_path,EMISSION);
  strcpy(s_reception.sun_path,RECEPTION);
  
  // initialisation
  lg = sizeof(s_reception);
  sock = socket(AF_UNIX,SOCK_DGRAM,0);
  
  connect(sock,(struct sockaddr *)&server,sizeof(server)); // appel bloquant jusqu' la connexion effective
  send(sock,mess2,sizeof(mess2),0,(struct sockaddr *)&s_reception,sizeof(s_reception));

  // attente

  recv(sock,mess2,sizeof(mess2),0,(struct sockaddr *)&s_reception,&lg);
  close(sock);
}

/***************************************
* Exercice 1 : Unix connect / Serveur *
***************************************/
#include <stdio.h>
#include <sys/socket.h>
#include <sys/un.h>
#define TAILLEMAX 4000
#define SERV "./sock"

void main()
{
  int sock,acc;
  char mess[TAILLEMAX];
  struct sockaddr_un server,client;
  
  bzero(&server,sizeof(server));
  strcpy(server.sun_path,SERV);
  server.sun_family = AF_UNIX;
  sock = socket(AF_UNIX,SOCK_STREAM,0);
  
  unlink(SERV);
  bind(sock,(struct sockaddr *)&server,sizeof(server));
  listen(sock,1);
  
  // attente du serveur bloquant
  
  acc = accept(sock,(struct sockaddr *)&client,(int *)&lg);
  recv(acc,mess,sizeof(mess),0);
  send(acc,mess,sizeof(mess),0);
  close(acc);
  close(sock);
}

/******************************************
* Exercice 2 : Unix connect FTP / Client *
******************************************/
#include <stdio.h>
#include <sys/socket.h>
#include <sys/un.h>
#define TAILLEMAX 4000
#define EMISSION "./sock_emission"
#define RECEPTION "./sock_reception"

void main()
{
  typedef struct TAMPON {
    int taille;
    char data[TAILLEMAX];
  } tampon;
  
  tampon tampon_emission;
  FILE* fp;
  int cc;
  char mess[TAILLEMAX],mess2[TAILLEMAX];
  struct sockaddr_un server,s_emission,s_reception;

  // initialisation
  unlink(EMISSION);
  unlink(RECEPTION);
  bzero(&s_emission,sizeof(s_emission));
  bzero(&s_reception,sizeof(s_reception));
  
  strcpy(s_emission.sun_path,EMISSION);
  strcpy(s_reception.sun_path,RECEPTION);
  
  // initialisation
  lg = sizeof(s_reception);
  sock = socket(AF_UNIX,SOCK_DGRAM,0);
  
  cc = connect(sock,(struct sockaddr *)&server,sizeof(server)); // appel bloquant jusqu' la connexion effective
  do {
    fread(tampon_emission.data,sizeof(char),tampon_emission.taille,fp);
    send(cc,(void *)&tampon_emission,tampon_emission.taille,0);
  }
  while (tampon_emission.taille,0);

  close(sock);
}

/*******************************************
* Exercice 2 : Unix connect FTP / Serveur *
*******************************************/
#include <stdio.h>
#include <sys/socket.h>
#include <sys/un.h>
#define TAILLEMAX 4000
#define EMISSION "./sock_emission"
#define RECEPTION "./sock_reception"

void main()
{
  typedef struct TAMPON {
    int taille;
    char data[TAILLEMAX];
  } tampon;
  
  tampon tampon_reception;
  FILE* fp;
  int sock,acc;
  char mess[TAILLEMAX];
  struct sockaddr_un server,client;
  
  bzero(&server,sizeof(server));
  strcpy(server.sun_path,SERV);
  server.sun_family = AF_UNIX;
  sock = socket(AF_UNIX,SOCK_STREAM,0);
  
  unlink(SERV);
  bind(sock,(struct sockaddr *)&server,sizeof(server));
  listen(sock,1);
  
  // attente du serveur bloquant

  acc = accept(sock,(struct sockaddr *)&client,(int *)&lg);
  fp = fopen(const(char *)nom_fich,"wb");
  recv(acc,(void *)&tampon_reception,tampon_reception.taille,0);
  
  do {
    fwrite(tampon_reception.data,sizeof(char)tampon_reception.taille,fp);
    recv(acc,(void *)&tampon_reception,tampon_reception.taille,0);
  } while (tampon_reception.taille > 0);

  fclose(fp);
  close(acc);
  close(sock);
}

/************************************
* Exercice 4 : sockets et processus *
************************************/
#include <sys/socket.h>
#include <stdio.h>
#include <sys/types.h>
#include <netinet/in.h>
#include <netdb.h>
#include <errno.h>
#include <sys/wait.h>

void main(int nbarg, char **argv){
  char bufferPere[100], bufferFils[100];
  int sock[2];
  int pid;
  int retour;

  if(socketpair(AF_UNIX,SOCK_STREAM,0,sock) < 0) {
    perror("socketpair");
    exit(0);
  }
  
  pid = fork();

  switch(pid) {
  case -1:
    perror("fork");
    exit(0);
    break;
  case 0:
    // je suis dans le fils
    close(sock[1]);
    printf("C'est le fils : attente de message\n");
    if(read(sock[0],bufferFils,100) < 0) {
      perror("read fils");
      exit(0);
    }
    printf("Le fils reoit : %s\n",bufferFils);
    strcpy(bufferFils,"OK message reu, dixit le fils");

    if(write(sock[0],bufferFils,strlen(bufferFils) + 1) < 0) {
      perror("fils write");
      exit(0);
    }
    exit(0);
    break;
  default:
    // je suis dans le pere
    sleep(2);
    close(sock[0]);
    strcpy(bufferPere,"je suis le pre");
    printf("C'est le pre : envoie du message\n");

    if(write(sock[1],bufferPere,strlen(bufferPere) + 1) < 0) {
      perror("pere write");
      exit(0);
    }

    if(read(sock[1],bufferPere,100) < 0) {
      perror("pere read");
      exit(0);
    }

    printf("Le pre : %s\n",bufferPere);
    waitpid(pid,&retour,0);
    exit(0);
    break;
  }
}
