/****************************************************/
/*                        Client                    */
/*       Utilisation : client nom_serveur_diff      */
/****************************************************/
#include "message.h"

int sock, at; /* descripteur de socket */
int reuse=1;  /* port reutilisable */
t_message message;
char nom[20];

extern void emettre_message(int client);
void recevoir_message(int client);
void traitant_SIGNAL(int n);

/**********************************************************/
/*                  recevoir_message()                    */
/* fonction permettant de recevoir un message du serveur  */
/**********************************************************/
void recevoir_message(int client)
{
   int test;

   test=read(client, &message, sizeof(message));
   if (test == -1)
     {
       perror("Erreur read : ");
       exit(1);
     }

   if (test==0)
     {
       printf("\nConnexion avec le serveur de diffusion coupee .\n\n");
       close(sock);
       exit(1);
     }
}

/***********************************************************/
/*                   traitant_SIGNAL()                     */
/*               fonction appelee par SIGINT               */
/*     realise la deconnexion du client aupres du serveur  */
/***********************************************************/
void traitant_SIGNAL(int n)
{
   message.type = D_CLIENT;
   emettre_message(sock);
   close(sock);
   printf("\n\nDeconnexion ...\n\n");
   exit(1);
}

/***********************************************************/
/*                   programme principal                   */
/***********************************************************/
void main(int argc, char *argv[])
{
   /* declaration des structures */
   struct sockaddr_in serveur;
   struct hostent *hp;
   struct sigaction action;

   /* installation d'un handler pour le signal SIGINT */
   signal(SIGINT, traitant_SIGNAL);

   /* test du nombre d'arguments */
   if (argc!=2)
     {
       printf("Usage : client nom_serveur_diff\n");
       exit(1);
     }

   hp=gethostbyname(argv[1]);
   /* creation de la socket de communication avec le serveur */
   sock=socket(AF_INET, SOCK_STREAM, 0);
   if (sock==-1)
     {
       perror("Erreur socket : ");
       exit(1);
     }

   /* initialisation de la structure serveur */
   bzero(&serveur, sizeof(serveur));
   serveur.sin_family=AF_INET;
   serveur.sin_port=htons(PORT_DC);
   bcopy(hp->h_addr, (char *)&serveur.sin_addr, hp->h_length);

   /* demande de connexion sur le serveur de diffusion */
   printf("\n\nDemande de connexion ...\n\n");
   if (connect(sock, (struct sockaddr *)&serveur, sizeof(serveur))==-1)
     {
       perror("Erreur connect ");
       exit(1);
     }

   /* envoie le nom du client diffuseur au serveur de diffusion */
   message.type=C_CLIENT;
   /* gethostname(message.mess, sizeof(message.mess)); */
   printf("Entrer votre identit : \n");
   gets(nom);
   strcpy(message.mess,nom);
   emettre_message(sock);

   /* boucle de traitement des messages arrivant du serveur */
   while (1)
     {
       /* lecture du message */
       recevoir_message(sock);

       /* on reoit des infos concernant le serveur de diffusion */
       if (message.type==INFO_SERVEUR)
         printf("\nBienvenue sur le serveur de diffusion %s\n\n", message.mess);

       /* on reoit des infos concernant le client de diffusion */
       if (message.type==INFO_DCLIENT)
         printf("\nLe client diffuseur est %s\n\n", message.mess);

       /* si message du diffuseur alors on l'affiche */
       if (message.type==M_DCLIENT)
         printf("\nLe message est %s\n\n", message.mess);

       /* si deconnexion du serveur alors on deconnecte le client */
       if (message.type==D_SERVEUR)
         {
           printf("\nConnexion coupee par le serveur ...\n\n");
           close(sock);
           exit(1);
         }

       /* si deconnexion du client diffuseur alors on deconnecte le client */
       if (message.type==D_DCLIENT)
         {
           printf("\nLe client diffuseur vient de se deconnecter ...\n\n");
           close(sock);
           exit(1);
         }
     }
}
