/****************************************************/
/*                  Client Diffuseur                */
/*    Utilisation : diff_client nom_serveur_diff    */
/****************************************************/

#include "message.h"

int sock; /* descripteur de socket */
int reuse=1;  /* port reutilisable */
t_message message;
char nom[20];

extern void emettre_message(int client);
void traitant_SIGPIPE(int n);
void traitant_SIGINT(int n);

/**************************************************/
/*               traitant_SIGPIPE()               */
/*           fonction appelee par SIGPIPE         */
/*     detecte la deconnexion brutale du serveur  */
/**************************************************/
void traitant_SIGPIPE(int n)
{
   printf("\n\nConnexion avec le serveur perdue ...\n\n");
   close(sock);
   raise(SIGPIPE);
   exit(1);
}

/***********************************************************/
/*                   traitant_SIGINT()                     */
/*               fonction appelee par SIGINT               */
/*     realise la deconnexion du client aupres du serveur  */
/***********************************************************/
void traitant_SIGINT(int n)
{
   message.type = D_DCLIENT;
   strcpy(message.mess, "");
   emettre_message(sock);
   close(sock);
   printf("\n\nDeconnexion ...\n\n");
   exit(1);
}

/***********************************************************/
/*                   programme principal                   */
/***********************************************************/
void main(int argc, char *argv[])
{
   /* declaration des structures */
   struct sockaddr_in serveur;
   struct hostent *hp;
   struct sigaction action;

   /* installation d'un handler pour le signal SIGINT */
   signal(SIGINT, traitant_SIGINT);
   /* installation d'un handler pour le signal SIGPIPE */
   signal(SIGPIPE, traitant_SIGPIPE);

   /* test du nombre d'arguments */
   if (argc!=2)
     {
       printf("Usage : diff_client nom_serveur_diff\n");
       exit(1);
     }

   hp=gethostbyname(argv[1]);
   /* creation de la socket de communication avec le serveur */
   sock=socket(AF_INET, SOCK_STREAM, 0);
   if (sock==-1)
     {
       perror("Erreur socket : ");
       exit(1);
     }

   /* initialisation de la structure serveur */
   bzero(&serveur, sizeof(serveur));
   serveur.sin_family=AF_INET;
   serveur.sin_port=htons(PORT_RM);
   bcopy (hp->h_addr, (char *)&serveur.sin_addr, hp->h_length);

   /* demande de connexion sur le serveur de diffusion */
   printf("\n\nConnexion sur le serveur de diffusion %s ...\n\n",hp->h_name);
   if (connect(sock, (struct sockaddr *)&serveur, sizeof(serveur))==-1)
     {
       perror("Erreur connect ");
       exit(1);
     }

   /* envoie le nom du client diffuseur au serveur de diffusion */
   message.type=INFO_DCLIENT;

   /* gethostname(message.mess, sizeof(message.mess)); */
   printf("Entrer votre identit : \n");
   gets(nom);
   strcpy(message.mess,nom);
   printf("le nom du client_diff est %s\n",message.mess);
   emettre_message(sock);

   /* boucle de traitement des messages envoyes au serveur */
   while (1)
     {
       message.type=M_DCLIENT;
       printf("Message a diffuser : ");
       gets(message.mess);
       emettre_message(sock);
     }
}
